adjust options parsing for new error handling method
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8 # shellcheck disable=SC2001,SC2181
9
10 # error_handler {{{
11 error_handler() {
12    last_exit_code="$?"
13    last_bash_command="$BASH_COMMAND"
14    echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
15 last bash command: $last_bash_command"
16    ## Check if "bailout" function is available.
17    ## This is not the case in chroot-script.
18    if command -v bailout >/dev/null 2>&1; then
19       bailout 1
20    else
21       exit 1
22    fi
23 }
24
25 set -e
26 set -E
27 set -o pipefail
28 trap "error_handler" ERR
29 export -f "error_handler"
30 # }}}
31
32 # variables {{{
33 PN="$(basename "$0")"
34 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
35   VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
36 else
37   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
38 fi
39 VERSION="${VERSION:-unknown}"
40 MNTPOINT="/mnt/debootstrap.$$"
41
42 # defaults
43 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
44 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
45 [ -n "$DEBCONF" ] || DEBCONF='yes'
46 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
47 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
48 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
49 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
50 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
51 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
52 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
53 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
54 [ -n "$FORCE" ] || FORCE=''
55 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
56 [ -n "$INITRD" ] || INITRD='yes'
57 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
58 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
59 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
60 [ -n "$LOCALES" ] || LOCALES='yes'
61 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
62 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
63 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
64 [ -n "$PACKAGES" ] || PACKAGES='yes'
65 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
66 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
67 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
68 [ -n "$RELEASE" ] || RELEASE='bookworm'
69 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
70 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
71 [ -n "$SECURE" ] || SECURE='yes'
72 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
73 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
74 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
75 [ -n "$VMSIZE" ] || VMSIZE="2G"
76 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
77
78 # inside the chroot system locales might not be available, so use minimum:
79 export LANG=C
80 export LC_ALL=C
81 export LANGUAGE=C
82
83 # make sure interactive mode is only executed when
84 # using an empty configuration file or option --interactive
85 INTERACTIVE=''
86 # }}}
87
88 # help text {{{
89 usage() {
90   echo "$PN - wrapper around debootstrap for installing Debian
91
92 Usage: $PN [options]
93
94 Bootstrap options:
95
96   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
97   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
98                          instead of fetching packages from a mirror.
99   -r, --release <name>   Release of new Debian system (default: bullseye).
100   -t, --target <target>  Target partition (/dev/...) or directory where the
101                          system should be installed to.
102   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
103                          has no effect if -t is given and represents a directory.
104       --debopt <params>  Extra parameters passed to the debootstrap command.
105       --interactive      Use interactive mode (frontend).
106       --nodebootstrap    Skip debootstrap, only do configuration to the target.
107       --grub <device>    Target for grub installation. Usage example: /dev/sda
108       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
109       --arch <arch>      Set target architecture, use for installing i386 on amd64.
110       --filesystem <fs>  Filesystem that should be used when target is a partition
111                          or Virtual Machine (see --vmfile).
112       --force            Do not prompt for user acknowledgement.
113
114 Options for Virtual Machine deployment:
115
116       --vm               Set up a Virtual Machine on an existing block device
117                          instead of plainly installing to a partition or
118                          directory. Needs to be combined with --target.
119                          Example: --vm --target /dev/mapper/your-vm-disk
120       --vmfile           Like --vm, but install into a regular file (created by
121                          'qemu-img create -f raw ...') instead.
122                          Example: --vmfile --target /mnt/sda1/qemu.img
123       --vmsize <size>    Use specified size for size of VM file (default: 2G).
124                          Syntax as supported by qemu-img, like: --vmsize 3G
125       --vmefi            Create an EFI boot partition for the VM.
126
127 Configuration options:
128
129   -c, --config <file>      Use specified configuration file, defaults to
130                              /etc/debootstrap/config
131   -d, --confdir <path>     Place of config files for debootstrap, defaults
132                              to /etc/debootstrap
133       --packages <file>    Install packages defined in specified list file
134                              instead of using /etc/debootstrap/packages.
135       --nopackages         Skip installation of packages defined in
136                              /etc/debootstrap/packages
137       --nokernel           Skip installation of default kernel images.
138       --nointerfaces       Do not copy /etc/network/interfaces from host system
139                            to target system.
140                            (This option is automatically enabled when using --vmfile.)
141       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
142                            DHCP for eth0) instead of taking over config from host system.
143       --debconf <file>     Pre-seed packages using specified pre-seed db file.
144       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
145       --backportrepos      Enable Debian's backports repository (backports.debian.org).
146       --keep_src_list      Do not overwrite user provided apt sources.list.
147       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
148       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
149       --hostname <name>    Hostname of Debian system.
150       --nopassword         Do not prompt for the root password.
151       --password <pwd>     Use specified password as password for user root.
152       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
153       --sshcopyid          Use locally available public keys to authorise root login on the target system.
154       --bootappend <line>  Add specified appendline to kernel whilst booting.
155       --chroot-scripts <d> Execute chroot scripts from specified directory.
156       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
157       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
158       --remove-configs     Delete grml-debootstrap configuration files from installed system.
159
160 Other options:
161
162   -v, --verbose            Increase verbosity.
163       --debug              Execute in very verbose way.
164   -h, --help               Print this usage information and exit.
165   -V, --version            Show summary of options and exit.
166
167 Usage examples can be found in the grml-debootstrap manpage.
168 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
169 "
170 }
171
172 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
173    usage
174    echo 'Please notice that this script requires root permissions!'
175    exit 0
176 fi
177 # }}}
178
179 # early helper functions {{{
180 # skip colors when running within a dumb terminal
181 if [ "${TERM}" = "dumb" ] ; then
182   GOOD=
183   BAD=
184   WARN=
185   NORMAL=
186 else
187   GOOD='\e[32;01m'
188   BAD='\e[31;01m'
189   WARN='\e[33;01m'
190   NORMAL='\e[0m'
191 fi
192
193 einfo() {
194   einfon "$1\\n"
195   return 0
196 }
197
198 einfon() {
199   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
200   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
201   LAST_E_CMD=einfon
202   return 0
203 }
204
205 ewarn() {
206   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
207   return 0
208 }
209
210 eerror() {
211   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
212   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
213   LAST_E_CMD=eerror
214   return 0
215 }
216
217 eend() {
218   local retval="${1:-0}"
219   shift
220   if [ "$retval" -gt 0 ]; then
221     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
222   fi
223   return "$retval"
224 }
225
226 check4root(){
227   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
228     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
229   fi
230 }
231
232 check4progs(){
233   local RC=''
234   for arg in "$@" ; do
235     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
236   done
237   if [ -n "$RC" ] ; then
238      echo "$RC not installed"
239      return 1
240   fi
241 }
242 # }}}
243
244 # helper functions {{{
245 cleanup() {
246   if [ -n "$CHROOT_VARIABLES" ] ; then
247     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" || eend $?
248   fi
249
250   if [ -n "$STAGES" ] ; then
251     einfo "Removing ${STAGES}" ; rmdir "$STAGES" || eend $?
252   fi
253
254   if [ -n "$ARM_EFI_TARGET" ]; then
255     umount "${MNTPOINT}/boot/efi" >/dev/null 2>&1
256   fi
257
258   # Remove temporary mountpoint again
259   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
260     if [ -d "$MNTPOINT" ] ; then
261       rmdir "$MNTPOINT"
262     fi
263   fi
264
265   # make sure $TARGET is not mounted when exiting grml-debootstrap
266   if [ -n "$MNTPOINT" ] ; then
267     if grep -q "$MNTPOINT" /proc/mounts ; then
268       # make sure nothing is left inside chroot so we can unmount it
269       for service in ssh mdadm ; do
270         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
271           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
272         fi
273       done
274
275       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
276
277       # ugly, but make sure we really don't leave anything (/proc /proc and
278       # /dev /dev are intended, trying to work around timing issues, see #657023)
279       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
280         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
281         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
282       done
283
284       if [ -n "$ISODIR" ] ; then
285         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
286       fi
287
288       if [ -n "$DIRECTORY" ] ; then
289         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
290       else
291         einfo "Unmounting $MNTPOINT"
292         umount "$MNTPOINT" || eend $?
293       fi
294
295       if [ -n "$STAGES" ] ; then
296         echo -n "Removing stages directory ${STAGES}: "
297         rm -rf "$STAGES" && echo 'done'
298       fi
299
300       # remove directory only if we used the default with process id inside the name
301       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
302         if test -d "$MNTPOINT" ; then
303           einfo "Removing directory ${MNTPOINT}"
304           rmdir "$MNTPOINT" || eend $?
305         fi
306       fi
307     fi
308   fi
309
310   if [ -n "${ORIG_TARGET}" ] ; then
311     einfo "Removing loopback mount of file ${ORIG_TARGET}."
312     kpartx -d "${ORIG_TARGET}" || eend $?
313     # Workaround for a bug in kpartx which doesn't clean up properly,
314     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
315     if dmsetup ls | grep -q "^${LOOP_PART} "; then
316       kpartx -d "/dev/${LOOP_DISK}" >/dev/null || eend $?
317     fi
318   fi
319 }
320
321 # we want to exit smoothly and clean:
322 bailout(){
323   eend "$1" || true
324
325   cleanup
326
327   [ -n "$1" ] && EXIT="$1" || EXIT="1"
328   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
329
330   exit "$EXIT"
331 }
332 trap bailout HUP INT QUIT TERM
333
334 # we want to execute all the functions only once, simple check for it:
335 stage() {
336   if [ -n "$2" ] ; then
337      echo "$2" > "${STAGES}/${1}"
338      return 0
339   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
340      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
341      ewarn "  To reexecute it clean up the according directory inside $STAGES"
342      return 1
343   fi
344 }
345 # }}}
346
347 # source main configuration file {{{
348 if [ -r /etc/debootstrap/config ] ; then
349   # shellcheck disable=SC1091
350   . /etc/debootstrap/config
351 fi
352 # }}}
353
354 # cmdline handling {{{
355 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
356
357 if ! _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
358   $CMDLINE_OPTS -- "$@"); then
359   eerror "Try 'grml-debootstrap --help' for more information."
360   bailout 1
361 fi
362 eval set -- "$_opt_temp"
363
364 while :; do
365   case "$1" in
366
367   # == Bootstrap options
368   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
369     shift; _opt_mirror="$1"
370     ;;
371   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
372     shift; _opt_iso="$1"
373     ;;
374   --release|-r)        # Release of new Debian system
375     shift; _opt_release="$1"
376     ;;
377   --target|-t)         # Target partition (/dev/...) or directory
378     shift; _opt_target="$1"
379     ;;
380   --vm)                # Virtual machine image (no file)
381     _opt_vm="T"
382     ;;
383   --vmfile)            # Virtual machine file
384     _opt_vmfile="T"
385     ;;
386   --vmsize)            # size of Virtual machine file
387     shift; _opt_vmsize="$1"
388     ;;
389   --vmefi)            # Create an EFI boot partition for the VM
390     _opt_vmefi="T"
391     ;;
392   --mntpoint|-p)       # Mountpoint used for mounting the target system
393     shift; _opt_mntpoint="$1"
394     ;;
395   --debopt)            # Extra parameters passed to the debootstrap command
396     shift; _opt_debopt="$1"
397     ;;
398   --filesystem)        # Filesystem that should be used
399     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
400     ;;
401   --interactive)       # Use interactive mode (frontend)
402     _opt_interactive=T
403     ;;
404   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
405     _opt_nodebootstrap=T
406     ;;
407   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
408     _opt_nopackages=T
409     ;;
410   --arch)              # Target architecutre
411     shift; _opt_arch="$1"
412     ;;
413   # just for backwards compatibility
414   --insecure)
415     _opt_insecure=T
416     ;;
417   #
418
419   # == Configuration options
420   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
421     shift; _opt_config="$1"
422     ;;
423   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
424     shift; _opt_confdir="$1"
425     ;;
426   --packages)          # Install packages defined in specified file
427     shift; _opt_packages="$1"
428     _opt_packages_set=T
429     ;;
430   --debconf)           # Pre-seed packages using specified file
431     shift; _opt_debconf="$1"
432     _opt_debconf_set=T
433     ;;
434   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
435     shift; _opt_pre_scripts="$1"
436     _opt_pre_scripts_set=T
437     ;;
438   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
439     shift; _opt_scripts="$1"
440     _opt_scripts_set=T
441     ;;
442   --post-scripts)       # Execute scripts from specified directory
443     shift; _opt_post_scripts="$1"
444     _opt_post_scripts_set=T
445     ;;
446   --chroot-scripts)   # Execute chroot scripts from specified directory
447     shift; _opt_chroot_scripts="$1"
448     _opt_chroot_scripts_set=T
449     ;;
450   --keep_src_list)     # Do not overwrite user provided apt sources.list
451     _opt_keep_src_list=T
452     ;;
453   --hostname)          # Hostname of Debian system
454     shift; _opt_hostname="$1"
455     ;;
456   --password)          # Use specified password as password for user root
457     shift; _opt_password="$1"
458     ;;
459   --defaultinterfaces) # Install default /etc/network/interfaces
460     _opt_defaultinterfaces=T
461     ;;
462   --nointerfaces)      # Skip installation of /etc/network/interfaces
463     _opt_nointerfaces=T
464     ;;
465   --nokernel)          # Skip installation of default kernel images
466     _opt_nokernel=T
467     ;;
468   --nopassword)        # Skip password dialog
469     _opt_nopassword=T
470     ;;
471   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
472     _opt_sshcopyid=T
473     ;;
474   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
475     _opt_sshcopyauth=T
476     ;;
477   --grmlrepos)         # Enable Grml repository
478     _opt_grmlrepos=T
479     ;;
480   --backportrepos)     # Enable Debian backports repository
481     _opt_backportrepos=T
482     ;;
483   --bootappend)        # Add specified appendline to kernel whilst booting
484     shift; _opt_bootappend="$1"
485     ;;
486   --grub)              # Target for grub installation. Use grub syntax for specifying
487     shift; _opt_grub="$1"
488     ;;
489   --efi)               # Target for EFI boot installation
490     shift; _opt_efi="$1"
491     ;;
492   --contrib)           # Add 'contrib' to list of components
493     _opt_contrib=T
494     ;;
495   --non-free)          # Add 'non-free' to list of components
496     _opt_non_free=T
497     ;;
498   --remove-configs)    # Drop config files from installed system
499     _opt_remove_configs=T
500     ;;
501
502   # == Other options
503   --verbose|-v)        # Increase verbosity
504     if [ "$_opt_verbose" ]; then
505       _opt_verbose=$( _opt_verbose + 1 )
506     else
507       _opt_verbose=1
508     fi
509     ;;
510   --debug)             # Execute in debug mode
511     _opt_debug=T
512     ;;
513   --help|-h)           # Print usage information and exit
514     _opt_help=T
515     ;;
516   --version|-V)        # Show version information and exit
517     _opt_version=T
518     ;;
519   --force)             # Do not prompt for user input
520     _opt_force=T
521     ;;
522   --)
523     shift; break
524     ;;
525   *)
526     eerror "Internal getopt error!"; eend 1 ; exit 1
527     ;;
528   esac
529   shift
530 done
531
532 # == business-logic of command line parameter-processing
533
534 # source configuration file in <confdir> if supplied. {{{
535 [ "$_opt_confdir" ] && {
536   CONFFILES=$_opt_confdir
537   einfo "Using config files under $CONFFILES/."
538   if ! [ -r "$CONFFILES/config" ] ; then
539     eerror "Error: config file $CONFFILES/config not found."; bailout 1
540   fi
541   # shellcheck disable=SC1091 source=config
542   if ! . "$CONFFILES/config" ; then
543     eerror "Error reading config file $CONFFILES/config" ; bailout 1
544   fi
545   # restore the command line parameter value
546   CONFFILES=$_opt_confdir
547 }
548 # }}}
549
550 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
551 [ "$_opt_iso" ]                 && ISO=$_opt_iso
552 [ "$_opt_release" ]             && RELEASE=$_opt_release
553 [ "$_opt_target" ]              && TARGET=$_opt_target
554 [ "$_opt_vm" ]                  && VIRTUAL=1
555 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
556 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
557 [ "$_opt_vmefi" ]               && VMEFI=1
558 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
559 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
560 [ "$_opt_interactive" ]         && INTERACTIVE=1
561 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
562 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
563 [ "$_opt_packages_set" ]        && PACKAGES='yes'
564 [ "$_opt_nopackages" ]          && PACKAGES=''
565 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
566 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
567 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
568 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
569 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
570 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
571 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
572 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
573 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
574 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
575 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
576 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
577 [ "$_opt_nokernel" ]            && NOKERNEL="true"
578 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
579 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
580 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
581 [ "$_opt_grub" ]                && GRUB=$_opt_grub
582 [ "$_opt_efi" ]                 && EFI=$_opt_efi
583 [ "$_opt_arch" ]                && ARCH=$_opt_arch
584 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
585 [ "$_opt_force" ]               && FORCE=$_opt_force
586 [ "$_opt_verbose" ]             && VERBOSE="-v"
587 [ "$_opt_debug" ]               && DEBUG="true"
588 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
589
590 # make sure main is always included
591 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
592 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
593
594 case "${RELEASE}" in
595   jessie|stretch|buster|bullseye)
596     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
597     ;;
598   *)
599     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
600     ;;
601 esac
602
603 # command line option checks
604 if [ "$_opt_scripts_set" ] ; then
605   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
606   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
607 fi
608
609 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
610   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
611   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
612   bailout 1
613 fi
614
615 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
616   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
617   bailout 1
618 fi
619
620 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
621   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
622   eerror "Either drop the --iso ... option or use plain debootstrap instead."
623   bailout 1
624 fi
625
626 if [ "$DEBUG" = "true" ] ; then
627   set -x
628 fi
629
630 [ "$_opt_help" ] && {
631   usage
632   exit 0
633 }
634
635 [ "$_opt_version" ] && {
636   einfo "$PN - version $VERSION"
637   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
638   exit 0
639 }
640 # }}}
641
642 # check for root permissions {{{
643 if ! check4root ; then
644    echo "For usage instructions please execute '$PN --help'."
645    bailout 1
646 fi
647 # }}}
648
649 # make sure we have what we need {{{
650 check4progs "${DEBOOTSTRAP}" || bailout 1
651
652 if [ -n "$VIRTUAL" ] ; then
653   check4progs kpartx parted qemu-img || bailout 1
654 fi
655 # }}}
656
657 # source specified configuration file {{{
658 if [ -n "$CONFIGFILE" ] ; then
659   einfo "Reading specified config file $CONFIGFILE."
660   # shellcheck disable=SC1091 source=config
661   if ! . "$CONFIGFILE" ; then
662     eerror "Error reading config file $CONFIGFILE" ; bailout 1
663   fi
664 fi
665 # }}}
666
667 # backwards compatibility checks {{{
668 if [ -n "$GROOT" ] ; then
669    eerror "Error: you seem to have \$GROOT configured."
670    eerror "This variable is no longer supported, please visit the"
671    eerror "grml-debootstrap documentation for details."
672    bailout 1
673 fi
674
675 if echo "$GRUB" | grep -q '^hd' ; then
676    eerror "Error: this syntax for the grub configuration variable is no longer supported."
677    eerror "Please do not use hd... any longer but /dev/sdX instead."
678    bailout 1
679 fi
680 # }}}
681
682 # welcome screen {{{
683 welcome_dialog()
684 {
685    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
686 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
687 }
688 # }}}
689
690 # ask for target {{{
691 prompt_for_target()
692 {
693   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
694                sed 's/*//' | \
695                grep -v 'Extended$' | \
696                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
697
698   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
699      dialog --title "$PN" --trim \
700      --msgbox "Sorry, no partitions found. Please configure your
701      harddisks (see /proc/partitions) using a tool like fdisk,
702      cfdisk, gpart, gparted,..." 0 0 || bailout 1
703   fi
704
705   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
706                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
707                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
708                      echo "$i" "$fs"
709                      unset fs
710                    done)
711
712   # shellcheck disable=SC2086
713   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
714          --menu "Please select the target partition:" 0 0 0 \
715          $PARTITION_LIST) || bailout 1
716 }
717 # }}}
718
719 # ask for bootmanager {{{
720 prompt_for_bootmanager()
721 {
722   ADDITIONAL_PARAMS=""
723
724   if echo "$TARGET" | grep -q "/dev/md" ; then
725      MBRPART="all disks of Software RAID $TARGET"
726   else
727      # figure out whole disk device
728      found=
729      for device in /dev/disk/by-id/*
730      do
731         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
732         found=1
733         break
734      done
735      # shellcheck disable=SC2001
736      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
737      if [ -e "$MBRDISK" ]; then
738         MBRDISK=$(readlink -f "$MBRDISK")
739      else
740         # fall back to old behaviour
741         # shellcheck disable=SC2001
742         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
743      fi
744
745      MBRPART="MBR of $MBRDISK"
746   fi
747
748   for device in cciss/c0d0 sda hda; do
749     if [ "/dev/$device" != "${MBRDISK}" ]; then
750       grep -q $device /proc/partitions && \
751       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
752     fi
753   done
754   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
755
756   OIFS="$IFS"; IFS=:
757
758   # shellcheck disable=SC2086
759   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
760           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
761             mbr       "install bootmanager into $MBRPART" \
762             nowhere   "do not install bootmanager at all" \
763           ${ADDITIONAL_PARAMS}) || bailout 3
764   IFS="$OIFS"
765
766   case "$GETMBR" in
767     mbr)
768       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
769       if echo "$TARGET" | grep -q "/dev/md" ; then
770         GRUB="$TARGET"
771       else
772         GRUB="$MBRDISK"
773       fi
774       ;;
775     hda)
776       GRUB="/dev/hda"
777       ;;
778     sda)
779       GRUB="/dev/sda"
780       ;;
781     nowhere)
782       GRUB=''
783       ;;
784   esac
785 }
786 # }}}
787
788 # ask for Debian release {{{
789 prompt_for_release()
790 {
791   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
792   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
793             "Please enter the Debian release you would like to use for installation:" \
794             0 50 8 \
795             buster   Debian/10 \
796             bullseye Debian/11 \
797             bookworm Debian/12 \
798             sid      Debian/unstable)" \
799             || bailout
800 }
801 # }}}
802
803 # ask for hostname {{{
804 prompt_for_hostname()
805 {
806   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
807             "Please enter the hostname you would like to use for installation:" \
808             0 0 "$HOSTNAME")" || bailout
809 }
810 # }}}
811
812 # ask for password {{{
813 prompt_for_password()
814 {
815   if [ "$_opt_nopassword" ] ; then
816     einfo "Skip asking for root password as requested."
817     return 0
818   fi
819
820   ROOTPW1='PW1'
821   ROOTPW2='PW2'
822   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
823     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
824     "Please enter the password for the root account:" 10 60) || bailout
825
826     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
827     "Please enter the password for the root account again for \
828     confirmation:" 10 60) || bailout
829
830     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
831       dialog --stdout --title "${PN}" --ok-label \
832         "Retry" --msgbox "Passwords do not match!" 10 60
833     fi
834   done
835   ROOTPASSWORD="$ROOTPW1"
836 }
837 # }}}
838
839 # ask for Debian mirror {{{
840 prompt_for_mirror()
841 {
842   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
843
844   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
845           --menu "Where do you want to install from?" 0 0 0 \
846             net   "install via network (downloading from mirror)" \
847             local "install from local directory/mirror"
848           )
849
850   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
851      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
852      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
853                "Please enter Debian mirror you would like to use for installing packages." \
854                0 0 $MIRROR)" || bailout
855
856   else # CHOOSE_MIRROR == local
857      [ -n "$ISO" ] || ISO='/mnt/mirror'
858      ISO="$(dialog --stdout --title "${PN}" --inputbox \
859                "Please enter directory name you would like to use for installing packages." \
860                0 0 $ISO)" || bailout
861   fi
862 }
863 # }}}
864
865 # software raid setup {{{
866 config_swraid_setup()
867 {
868 TMPFILE=$(mktemp)
869
870 # Currently we support only raid1:
871 RAIDLEVEL='raid1'
872
873 MD_LIST=$(for i in $(seq 0 9) ; do
874             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
875             echo "/dev/md$i /dev/md$i"
876           done)
877
878 # shellcheck disable=SC2086
879 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
880 --menu "Which device do you want to use for ${RAIDLEVEL}?
881
882 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
883 $MD_LIST) || bailout 20
884
885 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
886              sed 's/*//' | \
887              grep -v 'Extended$' | \
888              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
889 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
890 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
891                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
892                  done)
893
894 # shellcheck disable=SC2086
895 dialog --title "$PN" --separate-output \
896        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
897        $PARTITION_LIST 2>"$TMPFILE" || bailout
898
899 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
900
901 NUM_PARTITIONS=0
902 while IFS= read -r i; do
903   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
904 done < "$TMPFILE"
905
906 ERRORFILE=$(mktemp)
907 # shellcheck disable=SC2086
908 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
909       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
910 RC=$?
911 if [ "$RC" = 0 ] ; then
912    dialog --title "$PN" --msgbox \
913    "Creating $TARGET was successful." 0 0
914    rm -f "$TMPFILE" "$ERRORFILE"
915 else
916    dialog --title "$PN" --msgbox \
917    "There was an error setting up $TARGET:
918
919 $(cat "$ERRORFILE")
920
921 Exiting." 0 0
922    rm -f "$TMPFILE" "$ERRORFILE"
923    bailout 1
924 fi
925
926 }
927
928 prompt_for_swraid()
929 {
930 if dialog --stdout --title "$PN" \
931           --defaultno --yesno "Do you want to configure Software RAID?
932
933 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
934   config_swraid_setup
935 fi
936 }
937 # }}}
938
939 # user should recheck his configuration {{{
940 # support full automatic installation:
941 checkforrun() {
942    dialog --timeout 10 --title "$PN" \
943           --yesno "Do you want to stop at this stage?
944
945 Notice: you are running ${PN} in non-interactive mode.
946 ${PN} will install Debian ${RELEASE} on ${TARGET}.
947 Last chance to quit. Timeout of 10 seconds running....
948
949 Do you want to stop now?" 0 0 2>/dev/null
950 }
951 # }}}
952
953 # format efi partition {{{
954 format_efi_partition() {
955   if [ -z "$EFI" ] ; then
956     return 0
957   fi
958
959   if ! [ -b "$EFI" ] ; then
960     eerror "Specified efi argument [$EFI] not a valid block device."
961     bailout 1
962   fi
963
964   if fsck.vfat -bn "$EFI" >/dev/null; then
965     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
966   else
967     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
968     mkfs.fat -F32 -n "EFI" "$EFI"
969     RC=$?
970     if [ ! $RC -eq 0 ] ; then
971       eerror "Error while creating filesystem on ${EFI}."
972       bailout 1
973     fi
974   fi
975 }
976 # }}}
977
978 # check for EFI support or try to enable it {{{
979 efi_support() {
980   local efivars_loaded=false
981   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
982   if modprobe efivars &>/dev/null ; then
983     efivars_loaded=true
984   fi
985   # kernel versions v3.10 and newer usually provide efivarfs
986   if modprobe efivarfs &>/dev/null ; then
987     efivars_loaded=true
988   fi
989
990   if [ -d /sys/firmware/efi ] ; then
991     einfo "EFI support detected."
992     return 0
993   fi
994
995   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
996     einfo "EFI support detected, but system seems to be running in BIOS mode."
997   fi
998
999   return 1
1000 }
1001 # }}}
1002
1003 # make sure the user is aware of the used configuration {{{
1004 checkconfiguration()
1005 {
1006
1007 if [ -z "$VIRTUAL" ] ; then
1008   if efi_support ; then
1009     if [ -z "$_opt_efi" ] ; then
1010       ewarn "EFI support detected but no --efi option given, please consider enabling it."
1011     fi
1012   else
1013     if [ -n "$_opt_efi" ] ; then
1014       eerror "EFI option used but no EFI support detected."
1015       bailout 1
1016     fi
1017   fi
1018 fi
1019
1020 if [ -n "$AUTOINSTALL" ] ; then
1021    if checkforrun ; then
1022       eerror "Exiting as requested"
1023       bailout 1
1024    fi
1025 elif [ -n "$INTERACTIVE" ] ; then
1026
1027    INFOTEXT="Please recheck configuration before execution:
1028    "
1029    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1030    Target:          $TARGET"
1031    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1032    Install grub:    $GRUB"
1033    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1034    Install efi:     $EFI"
1035    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1036    Using release:   $RELEASE"
1037    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1038    Using hostname:  $HOSTNAME"
1039    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1040    Using mirror:    $MIRROR"
1041    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1042    Using ISO:       $ISO"
1043    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1044    Using arch:      $ARCH"
1045    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1046    Config files:    $CONFFILES"
1047
1048    INFOTEXT="$INFOTEXT
1049
1050 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1051
1052    dialog --title "$PN" --no-collapse \
1053           --yesno "$INFOTEXT" 0 0
1054    [ $? -eq 0 ] || bailout 0
1055
1056 else # if not running automatic installation display configuration and prompt for execution:
1057    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1058    echo
1059    echo "   Target:          $TARGET"
1060
1061    # do not display if MNTPOINT is the default one
1062    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1063
1064    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1065       echo "   Install grub:    yes"
1066       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1067    else
1068      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1069      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1070    fi
1071
1072    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1073    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1074    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1075    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1076    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1077    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1078    if [ -n "$VIRTUAL" ] ; then
1079       echo "   Deploying as Virtual Machine."
1080       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1081          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1082       fi
1083    fi
1084
1085    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1086       echo
1087       echo "   You do not have a TTY allocated, your password will be shown in"
1088       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1089    fi
1090
1091    echo
1092    echo "   Important! Continuing will delete all data from ${TARGET}!"
1093
1094    if [ -n "$FORCE" ] ; then
1095      einfo "Skip user acknowledgement as requested via --force option."
1096    else
1097      echo
1098      einfon "Is this ok for you? [y/N] "
1099      read -r a
1100      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1101         eerror "Exiting as requested."
1102         bailout 1
1103      fi
1104    fi
1105 fi
1106 }
1107 # }}}
1108
1109 # interactive mode {{{
1110 interactive_mode()
1111 {
1112   check4progs dialog || bailout 1
1113
1114   welcome_dialog
1115
1116   prompt_for_release
1117
1118   prompt_for_swraid
1119
1120   prompt_for_target
1121
1122   prompt_for_bootmanager
1123
1124   prompt_for_hostname
1125
1126   prompt_for_password
1127
1128   prompt_for_mirror
1129 }
1130
1131 # run interactive mode if we didn't get the according configuration yet
1132 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1133    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1134    INTERACTIVE=1
1135    interactive_mode
1136 fi
1137 # }}}
1138
1139 # architecture setup {{{
1140 if [ -n "$ARCH" ] ; then
1141    ARCHCMD="--arch $ARCH"
1142    ARCHINFO=" (${ARCH})"
1143 else
1144    ARCH="$(dpkg --print-architecture)"
1145    ARCHCMD="--arch $ARCH"
1146    ARCHINFO=" (${ARCH})"
1147 fi
1148
1149 if [ -z "${ARCH:-}" ] ; then
1150   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1151   eerror 'Consider setting the --arch ... option.'
1152   bailout 1
1153 fi
1154 # }}}
1155
1156 # It is not possible to build amd64 on i686. {{{
1157 CURRENT_ARCH="$(uname -m)"
1158 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1159    if [ "$ARCH" = "amd64" ] ; then
1160       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead."
1161       bailout 1
1162    fi
1163 fi
1164 # }}}
1165
1166 # Support for generic release codenames is unavailable. {{{
1167 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1168    eerror "Generic release codenames (stable, testing) are unsupported. \
1169 Please use specific codenames such as bullseye or bookworm."
1170    bailout 1
1171 fi
1172 # }}}
1173
1174 checkconfiguration
1175
1176 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1177 if [ -n "$TARGET" ] ; then
1178    SHORT_TARGET="${TARGET##*/}"
1179 else
1180    eerror "Please adjust $CONFFILES/config or..."
1181    eerror "... use the interactive version for configuration before running ${0}"
1182    bailout 1
1183 fi
1184 # }}}
1185
1186 # stages setup {{{
1187 if [ -z "$STAGES" ] ; then
1188    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1189    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1190 fi
1191
1192 if [ -r "$STAGES"/grml-debootstrap ] ; then
1193    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1194       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1195       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}"
1196    fi
1197 fi
1198 # }}}
1199
1200 # partition handling {{{
1201 PARTITION=''
1202 DIRECTORY=''
1203
1204 set_target_directory(){
1205     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1206     DIRECTORY=1
1207     MNTPOINT="$TARGET"
1208     MKFS=''
1209     TUNE2FS=''
1210     FSCK=''
1211     # make sure we normalise the path to an absolute directory name so something like:
1212     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1213     # works
1214     TARGET="$(readlink -f "$TARGET")"
1215 }
1216
1217 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1218     PARTITION=1
1219 else
1220     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1221     if [[ $TARGET == "/dev/"* ]]; then
1222       eerror "Error: Will not create target directory $TARGET in /dev."
1223       eerror "  Please check the partition(s) of the blockdevice."
1224       bailout 1
1225     fi
1226     set_target_directory
1227 fi
1228 # }}}
1229
1230 # make sure we have the right syntax when using an iso image {{{
1231 if [ -n "$ISO" ] ; then
1232    case $ISO in
1233       file*) # do nothing
1234       ;;
1235       *)
1236       ISO=file:$ISO
1237       ;;
1238    esac
1239 fi
1240 ISODIR=${ISO##file:}
1241 ISODIR=${ISODIR%%/}
1242 # }}}
1243
1244 # Debian ISOs do not contain signed Release files {{{
1245 if [ -n "$ISO" ] ; then
1246     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1247 fi
1248 # }}}
1249
1250 # create filesystem {{{
1251 mkfs() {
1252   if [ -n "$DIRECTORY" ] ; then
1253      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1254      return 0
1255   fi
1256
1257   if grep -q "$TARGET" /proc/mounts ; then
1258     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)"
1259     bailout 1
1260   fi
1261
1262   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1263   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1264   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1265     case "$MKFS" in
1266       mkfs.ext*)
1267         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1268         MKFS_OPTS="$MKFS_OPTS -F"
1269         ;;
1270     esac
1271   fi
1272
1273   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1274   # by default, which requires a recent version of tune2fs on the target system then,
1275   # so disable this feature for older Debian releases where it's known to be unsupported
1276   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1277     case "$RELEASE" in
1278       jessie)
1279         # assume a more recent version if we can't identify the version via dpkg-query
1280         local e2fsprogs_version
1281         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1282         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1283           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1284           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1285         fi
1286         ;;
1287     esac
1288   fi
1289
1290   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1291   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1292   # Disable this feature for Debian releases older than bookworm
1293   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1294     case "$RELEASE" in
1295       jessie|stretch|buster|bullseye)
1296         local e2fsprogs_version
1297         # assume a more recent version if we can't identify the version via dpkg-query
1298         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1299         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1300           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1301           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1302         fi
1303         ;;
1304     esac
1305   fi
1306
1307   if [ -n "$MKFS" ] ; then
1308
1309     if [ -n "${ARM_EFI_TARGET}" ] ; then
1310       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1311       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1312       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1313     fi
1314
1315     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1316     # shellcheck disable=SC2086
1317     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1318
1319     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1320       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1321         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1322         bailout 1
1323       else
1324         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1325         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1326       fi
1327     fi
1328
1329     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1330       einfo "Creating FAT filesystem on $EFI_TARGET"
1331       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1332     fi
1333
1334     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1335     # will fail to detect the uuid in the chroot
1336     if [ -n "$VIRTUAL" ] ; then
1337       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1338     elif echo "$TARGET" | grep -q "/dev/md" ; then
1339       blockdev --rereadpt "${TARGET}"
1340     else
1341       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1342       local main_device="${TARGET%%[0-9]*}"
1343       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1344       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1345         blockdev --rereadpt "$main_device"
1346       else
1347         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1348       fi
1349     fi
1350     # give the system 2 seconds, otherwise we might run into
1351     # race conditions :-/
1352     sleep 2
1353
1354     eend $RC
1355   fi
1356 }
1357 # }}}
1358
1359 # retrieve ID_FS_UUID {{{
1360 identify_target_uuid() {
1361   local device="$1"
1362
1363   if ! [ -b "$device" ] ; then
1364     return 1
1365   fi
1366
1367   eval "$(blkid -o udev "$1" 2>/dev/null)"
1368
1369   if [ -n "$ID_FS_UUID" ] ; then
1370     echo "$ID_FS_UUID"
1371   else
1372     return 1
1373   fi
1374 }
1375 # }}}
1376
1377 # identify TARGET_UUID {{{
1378 mountpoint_to_blockdevice() {
1379   TARGET_UUID=''
1380
1381   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1382   if [ -n "$TARGET_UUID" ] ; then
1383     einfo "Identified UUID $TARGET_UUID for $TARGET"
1384     return 0
1385   fi
1386
1387   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1388   for file in /sys/block/*/*/dev ; do
1389     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1390       local dev
1391       dev="${file%/dev}"
1392       dev="/dev/${dev##*/}"
1393       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1394
1395       if [ -n "$TARGET_UUID" ] ; then
1396         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1397         return 0
1398       fi
1399     fi
1400   done
1401 }
1402 # }}}
1403
1404 # modify filesystem settings {{{
1405 tunefs() {
1406   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1407      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1408      $TUNE2FS "$TARGET" </dev/null
1409   fi
1410 }
1411 # }}}
1412
1413 # mount the new partition or if it's a directory do nothing at all {{{
1414 mount_target() {
1415   if [ -n "$DIRECTORY" ] ; then
1416      einfo "Running grml-debootstrap on a directory, nothing to mount."
1417   else
1418      if grep -q "$TARGET" /proc/mounts ; then
1419         ewarn "$TARGET already mounted, continuing anyway."
1420      else
1421        if ! [ -d "${MNTPOINT}" ] ; then
1422           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1423        fi
1424        einfo "Mounting $TARGET to $MNTPOINT"
1425        mkdir -p "$MNTPOINT"
1426        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1427      fi
1428   fi
1429   if [ -n "$ISODIR" ] ; then
1430      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1431      mkdir -p "$MNTPOINT/$ISODIR"
1432      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1433   fi
1434 }
1435 # }}}
1436
1437 # prepare VM image for usage with debootstrap {{{
1438 prepare_vm() {
1439   if [ -z "$VIRTUAL" ] ; then
1440      return 0 # be quiet by intention
1441   fi
1442
1443   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1444      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1445      bailout 1
1446   fi
1447   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1448      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1449      bailout 1
1450   fi
1451
1452   # make sure loop module is present and a usable loop device exists
1453   modprobe -q loop
1454   if ! losetup -f >/dev/null 2>&1; then
1455     eerror "Error finding usable loop device"
1456     bailout 1
1457   fi
1458
1459   # if dm-mod isn't available then kpartx will fail with
1460   # "Is device-mapper driver missing from kernel? [...]"
1461   modprobe -q dm-mod
1462   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1463     eerror "Device-mapper support missing in kernel."
1464     bailout 1
1465   fi
1466
1467   ORIG_TARGET="$TARGET" # store for later reuse
1468
1469   if [ -n "$VMFILE" ]; then
1470     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1471   fi
1472   if [ -n "$VMEFI" ]; then
1473     parted -s "${TARGET}" 'mklabel gpt'
1474     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1475     parted -s "${TARGET}" 'set 1 boot on'
1476     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1477     parted -s "${TARGET}" 'set 2 bios_grub on'
1478     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1479
1480   else
1481     # arm64 support largely only exists for GPT
1482     if [ "$ARCH" = 'arm64' ]; then
1483       einfo "Setting up GPT partitions for arm64"
1484       parted -s "${TARGET}" 'mklabel gpt'
1485       parted -s "${TARGET}" 'mkpart EFI fat32 1MiB 10MiB'
1486       parted -s "${TARGET}" 'set 1 boot on'
1487       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1488     else
1489       parted -s "${TARGET}" 'mklabel msdos'
1490       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1491         einfo "Adjusting disk signature to a fixed (non-random) value"
1492         MBRTMPFILE=$(mktemp)
1493         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1494         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1495         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1496       fi
1497       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1498       parted -s "${TARGET}" 'set 1 boot on'
1499     fi
1500   fi
1501
1502   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1503   if [ -z "${DEVINFO}" ] ; then
1504     eerror "Error setting up loopback device."
1505     bailout 1
1506   fi
1507
1508   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1509   if [ "$ARCH" = 'arm64' ]; then
1510     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1511     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1512     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1513     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1514     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1515   fi
1516
1517   # hopefully this always works as expected
1518   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1519   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1520   if [ -n "$VMEFI" ]; then
1521     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1522     LOOP_PART="${LOOP_PART%p1}p3"
1523   fi
1524   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1525   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1526
1527   if [ -z "$TARGET" ] ; then
1528      eerror "Error: target could not be set to according /dev/mapper/* device."
1529      bailout 1
1530   fi
1531 }
1532 # }}}
1533
1534 # make VM image bootable {{{
1535 grub_install() {
1536   if [ -z "${VIRTUAL}" ] ; then
1537      return 0
1538   fi
1539   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1540     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1541     return 0
1542   fi
1543
1544   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1545     eerror "Error: Mounting ${TARGET} failed, can not continue."
1546     bailout 1
1547   fi
1548
1549   if [ -n "${ARM_EFI_TARGET}" ]; then
1550     mkdir -p "${MNTPOINT}/boot/efi"
1551     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}/boot/efi" ; then
1552       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue."
1553       bailout 1
1554     fi
1555   fi
1556
1557   mount -t proc none "${MNTPOINT}"/proc
1558   mount -t sysfs none "${MNTPOINT}"/sys
1559   mount -t devtmpfs udev "${MNTPOINT}"/dev
1560   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1561
1562   if [ -n "$ARM_EFI_TARGET" ]; then
1563     einfo "Installing Grub as bootloader into EFI."
1564
1565     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1566   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1567   # chroot-script skips installation for unset ${GRUB}
1568   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1569     einfo "Installing Grub as bootloader."
1570
1571     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1572       echo "Notice: grub-pc package not present yet, installing it therefore."
1573       # shellcheck disable=SC2086
1574       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1575     fi
1576
1577     mkdir -p "${MNTPOINT}/boot/grub"
1578     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1579       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader."
1580       bailout 1
1581     fi
1582     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1583
1584     if [ -n "$VMEFI" ]; then
1585
1586       mkdir -p "${MNTPOINT}"/boot/efi
1587       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1588
1589       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1590         echo "Notice: shim-signed package not present yet, installing it therefore."
1591         # shellcheck disable=SC2086
1592         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1593       fi
1594
1595       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1596         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1597           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1598           # shellcheck disable=SC2086
1599           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1600         fi
1601         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1602       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1603         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1604           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1605           # shellcheck disable=SC2086
1606           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1607         fi
1608         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1609         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1610       else
1611         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1612           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1613           # shellcheck disable=SC2086
1614           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1615         fi
1616         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1617         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1618       fi
1619     else
1620       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1621       case "${_opt_filesystem}" in
1622         f2fs)
1623           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1624           ;;
1625         xfs)
1626           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1627           ;;
1628         # NOTE - we might need to distinguish between further filesystems
1629         *)
1630           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1631           ;;
1632       esac
1633
1634       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1635       rm -f "${MNTPOINT}/tmp/core.img"
1636     fi
1637   fi
1638
1639   # workaround for Debian bug #918590 with lvm + udev:
1640   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1641   if [ -d /run/udev ] ; then
1642     einfo "Setting up bind-mount /run/udev"
1643     mkdir -p "${MNTPOINT}"/run/udev
1644     mount --bind /run/udev "${MNTPOINT}"/run/udev
1645   fi
1646
1647   if [ -n "${BOOT_APPEND}" ] ; then
1648     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1649     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1650   fi
1651
1652   einfo "Updating grub configuration file."
1653   chroot "${MNTPOINT}" update-grub
1654   chroot "${MNTPOINT}" sync
1655
1656   case "$RELEASE" in
1657     jessie)
1658       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1659       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1660       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1661       ;;
1662   esac
1663
1664   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1665     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1666     ewarn "Please note that your system might NOT be able to properly boot."
1667   elif [ -z "$ARM_EFI_TARGET" ]; then
1668     einfo "Adjusting grub.cfg for successful boot sequence."
1669     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1670   fi
1671
1672   # workaround for Debian bug #918590 with lvm + udev:
1673   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1674   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1675     einfo "Unmounting bind-mount /run/udev"
1676     umount "${MNTPOINT}"/run/udev
1677   fi
1678
1679   umount "${MNTPOINT}"/proc
1680   umount "${MNTPOINT}"/sys
1681   umount "${MNTPOINT}"/dev/pts
1682   try_umount 3 "${MNTPOINT}"/dev
1683
1684   if [ -n "$VMEFI" ]; then
1685     umount "${MNTPOINT}"/boot/efi
1686   fi
1687
1688 }
1689 # }}}
1690
1691 # unmount VM image {{{
1692 umount_target() {
1693   if [ -z "${VIRTUAL}" ] ; then
1694      return 0
1695   fi
1696
1697   if [ -n "${ARM_EFI_TARGET}" ]; then
1698     umount "${MNTPOINT}/boot/efi"
1699   fi
1700
1701   umount "${MNTPOINT}"
1702   kpartx -d "${ORIG_TARGET}" >/dev/null
1703   # Workaround for a bug in kpartx which doesn't clean up properly,
1704   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1705   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1706     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1707   fi
1708 }
1709 # }}}
1710
1711 # install main chroot {{{
1712 debootstrap_system() {
1713   if [ "$_opt_nodebootstrap" ]; then
1714      einfo "Skipping debootstrap as requested."
1715      return
1716   fi
1717
1718   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1719     :
1720   else
1721     eerror "Error: $MNTPOINT not mounted, can not continue."
1722     eend 1 ; exit 1
1723   fi
1724
1725   if [ -n "$ISO" ] ; then
1726     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1727     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1728     # shellcheck disable=SC2086
1729     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1730     RC=$?
1731   else
1732     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1733     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1734     # shellcheck disable=SC2086
1735     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1736     RC=$?
1737   fi
1738
1739   if [ $RC -ne 0 ] ; then
1740     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1741       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1742       einfo "Presenting last ten lines of debootstrap.log:"
1743       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1744       einfo "End of debootstrap.log"
1745     fi
1746   fi
1747
1748   eend $RC
1749 }
1750 # }}}
1751
1752 # prepare chroot via chroot-script {{{
1753 preparechroot() {
1754   einfo "Preparing chroot system"
1755
1756   # provide variables to chroot system
1757   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1758   touch "$CHROOT_VARIABLES"
1759   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1760   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1761   [ -n "$ARCH" ]                      && echo "ARCH='${ARCH//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1762   [ -n "$BACKPORTREPOS" ]             && echo "BACKPORTREPOS='${BACKPORTREPOS//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1763   [ -n "$BOOT_APPEND" ]               && echo "BOOT_APPEND='${BOOT_APPEND//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1764   [ -n "$CHROOT_SCRIPTS" ]            && echo "CHROOT_SCRIPTS='${CHROOT_SCRIPTS//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1765   [ -n "$COMPONENTS" ]                && echo "COMPONENTS='${COMPONENTS//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1766   [ -n "$CONFFILES" ]                 && echo "CONFFILES='${CONFFILES//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1767   [ -n "$DEBCONF" ]                   && echo "DEBCONF='${DEBCONF//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1768   [ -n "$DEBIAN_FRONTEND" ]           && echo "DEBIAN_FRONTEND='${DEBIAN_FRONTEND//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1769   [ -n "$DEBOOTSTRAP" ]               && echo "DEBOOTSTRAP='${DEBOOTSTRAP//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1770   [ -n "$DEFAULT_LOCALES" ]           && echo "DEFAULT_LOCALES='${DEFAULT_LOCALES//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1771   [ -n "$DEFAULT_LANGUAGE" ]          && echo "DEFAULT_LANGUAGE='${DEFAULT_LANGUAGE//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1772   [ -n "$EXTRAPACKAGES" ]             && echo "EXTRAPACKAGES='${EXTRAPACKAGES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1773   [ -n "$EFI" ]                       && echo "EFI='${EFI//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1774   [ -n "$FALLBACK_MIRROR" ]           && echo "FALLBACK_MIRROR='${FALLBACK_MIRROR//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1775   [ -n "$FILESYSTEM" ]                && echo "FILESYSTEM='${FILESYSTEM//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1776   [ -n "$FORCE" ]                     && echo "FORCE='${FORCE//\'/\'\\\'\'}'"                                       >> "$CHROOT_VARIABLES"
1777   [ -n "$GRMLREPOS" ]                 && echo "GRMLREPOS='${GRMLREPOS//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1778   [ -n "$GRUB" ]                      && echo "GRUB='${GRUB//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1779   [ -n "$HOSTNAME" ]                  && echo "HOSTNAME='${HOSTNAME//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1780   [ -n "$INITRD" ]                    && echo "INITRD='${INITRD//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1781   [ -n "$INITRD_GENERATOR" ]          && echo "INITRD_GENERATOR='${INITRD_GENERATOR//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1782   [ -n "$INITRD_GENERATOR_OPTS" ]     && echo "INITRD_GENERATOR_OPTS='${INITRD_GENERATOR_OPTS//\'/\'\\\'\'}'"       >> "$CHROOT_VARIABLES"
1783   [ -n "$INSTALL_NOTES" ]             && echo "INSTALL_NOTES='${INSTALL_NOTES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1784   [ -n "$ISODIR" ]                    && echo "ISODIR='${ISO//\'/\'\\\'\'}'"                                        >> "$CHROOT_VARIABLES"
1785   [ -n "$ISO" ]                       && echo "ISO='${ISO//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1786   [ -n "$KEEP_SRC_LIST" ]             && echo "KEEP_SRC_LIST='${KEEP_SRC_LIST//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1787   [ -n "$LOCALES" ]                   && echo "LOCALES='${LOCALES//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1788   [ -n "$MIRROR" ]                    && echo "MIRROR='${MIRROR//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1789   [ -n "$MKFS" ]                      && echo "MKFS='${MKFS//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1790   [ -n "$NOPASSWORD" ]                && echo "NOPASSWORD=\"true\""                                                 >> "$CHROOT_VARIABLES"
1791   [ -n "$NOKERNEL" ]                  && echo "NOKERNEL=\"true\""                                                   >> "$CHROOT_VARIABLES"
1792   [ -n "$PACKAGES" ]                  && echo "PACKAGES='${PACKAGES//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1793   [ -n "$POST_SCRIPTS" ]              && echo "POST_SCRIPTS='${POST_SCRIPTS//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1794   [ -n "$PRE_SCRIPTS" ]               && echo "PRE_SCRIPTS='${PRE_SCRIPTS//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1795   [ -n "$RECONFIGURE" ]               && echo "RECONFIGURE='${RECONFIGURE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1796   [ -n "$RELEASE" ]                   && echo "RELEASE='${RELEASE//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1797   [ -n "$RM_APTCACHE" ]               && echo "RM_APTCACHE='${RM_APTCACHE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1798   [ -n "$ROOTPASSWORD" ]              && echo "ROOTPASSWORD='${ROOTPASSWORD//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1799   [ -n "$SCRIPTS" ]                   && echo "SCRIPTS='${SCRIPTS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1800   [ -n "$SECURE" ]                    && echo "SECURE='${SECURE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1801   [ -n "$SELECTED_PARTITIONS" ]       && echo "SELECTED_PARTITIONS='${SELECTED_PARTITIONS//\'/\'\\\'\'}'"           >> "$CHROOT_VARIABLES"
1802   [ -n "$TARGET" ]                    && echo "TARGET='${TARGET//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1803   [ -n "$UPGRADE_SYSTEM" ]            && echo "UPGRADE_SYSTEM='${UPGRADE_SYSTEM//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1804   [ -n "$TARGET_UUID" ]               && echo "TARGET_UUID='${TARGET_UUID//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1805   [ -n "$TIMEZONE" ]                  && echo "TIMEZONE='${TIMEZONE//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1806   [ -n "$TUNE2FS" ]                   && echo "TUNE2FS='${TUNE2FS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1807   [ -n "$VMSIZE" ]                    && echo "VMSIZE='${VMSIZE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1808
1809   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1810   chmod 755 "${MNTPOINT}"/bin/chroot-script
1811   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1812
1813   # make sure we have our files for later use via chroot-script
1814   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1815   # make sure we adjust the configuration variables accordingly:
1816   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1817   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1818   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1819
1820   # install notes:
1821   if [ -n "$INSTALL_NOTES" ] ; then
1822      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1823   fi
1824
1825   # package selection:
1826   if [ "$PACKAGES" = 'yes' ] ; then
1827     PACKAGES_FILE="packages"
1828
1829     if [ "$ARCH" = 'arm64' ]; then
1830       PACKAGES_FILE="packages-arm64"
1831     fi
1832
1833     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1834       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1835   fi
1836
1837   # debconf preseeding:
1838   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1839   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1840     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1841
1842   # copy scripts that should be executed inside the chroot:
1843   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1844   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1845     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1846     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1847   }
1848
1849   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1850   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1851
1852   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1853
1854   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1855   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1856
1857   # setup default locales
1858   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1859
1860   # copy any existing files to chroot
1861   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1862   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1863   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1864   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1865   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1866   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1867   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1868
1869   # network setup
1870   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1871
1872 # Include files from /etc/network/interfaces.d when using
1873 # ifupdown v0.7.44 or newer:
1874 #source-directory /etc/network/interfaces.d
1875
1876 auto lo
1877 iface lo inet loopback
1878
1879 allow-hotplug eth0
1880 iface eth0 inet dhcp
1881 "
1882
1883   # add dhcp setting for Predictable Network Interface Names
1884   if [ -x /bin/udevadm ]; then
1885     tmpfile=$(mktemp)
1886     for interface in /sys/class/net/*; do
1887       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1888       # skip virtual devices, like bridges, vboxnet,...
1889       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1890         continue
1891       fi
1892
1893       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1894       # use and stop on first match to have same behavior as udev's link_config_apply()
1895       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1896         if grep -q "${property}" "${tmpfile}" ; then
1897           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1898           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1899 allow-hotplug ${interface}
1900 iface ${interface} inet dhcp
1901 "
1902           break
1903         fi
1904       done
1905     done
1906     rm -f "${tmpfile}"
1907   fi
1908
1909   if [ -n "$NOINTERFACES" ] ; then
1910     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1911   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1912     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1913     mkdir -p "${MNTPOINT}/etc/network"
1914     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1915   elif [ -n "$VIRTUAL" ] ; then
1916     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1917     mkdir -p "${MNTPOINT}/etc/network"
1918     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1919   elif [ -r /etc/network/interfaces ] ; then
1920     einfo "Copying /etc/network/interfaces from host to target system"
1921     mkdir -p "${MNTPOINT}/etc/network"
1922     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1923   else
1924     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1925     mkdir -p "${MNTPOINT}/etc/network"
1926     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1927   fi
1928
1929   # install config file providing some example entries
1930   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1931     mkdir -p "${MNTPOINT}/etc/network"
1932     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1933   fi
1934
1935   if [ -n "${SSHCOPYID}" ] ; then
1936     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1937     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1938     if ssh-add -L >/dev/null 2>&1 ; then
1939       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1940       mkdir -p "${MNTPOINT}"/root/.ssh
1941       chmod 0700 "${MNTPOINT}"/root/.ssh
1942       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1943         eerror "Error: executing 'ssh-add -L' failed."
1944         bailout 1
1945       fi
1946     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1947       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1948       mkdir -p "$AUTHORIZED_KEYS_TARGET"
1949       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
1950       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
1951         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
1952         bailout 1
1953       fi
1954     else
1955       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
1956       bailout 1
1957     fi
1958   fi
1959
1960   if [ -n "${SSHCOPYAUTH}" ] ; then
1961     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
1962
1963     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
1964       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
1965       bailout 1
1966     fi
1967
1968     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
1969     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
1970     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
1971     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
1972     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
1973       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
1974       bailout 1
1975     fi
1976   fi
1977
1978   if [ -d /run/udev ] ; then
1979     einfo "Setting up bind-mount /run/udev"
1980     mkdir -p "${MNTPOINT}"/run/udev
1981     mount --bind /run/udev "${MNTPOINT}"/run/udev
1982   fi
1983 }
1984 # }}}
1985
1986 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1987 execute_pre_scripts() {
1988   # make sure hostname is set even before chroot-script get executed
1989   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
1990
1991   # make sure we have $MNTPOINT available for our scripts
1992   export MNTPOINT
1993
1994   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1995     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
1996     for script in "${pre_scripts}"/* ; do
1997       if [ -x "$script" ] ; then
1998         einfo "Executing pre-script $script"
1999         "$script"
2000       fi
2001     done
2002   fi
2003 }
2004 # }}}
2005
2006 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
2007 execute_post_scripts() {
2008   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
2009   export MNTPOINT
2010   export TARGET_HOSTNAME=$HOSTNAME
2011
2012   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2013     # legacy support for /etc/debootstrap/scripts/
2014     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2015     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2016   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2017     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2018   fi
2019
2020   if [ -n "$post_scripts" ] ; then
2021     for script in "${post_scripts}"/* ; do
2022       if [ -x "$script" ] ; then
2023         einfo "Executing post-script $script"
2024         "$script"
2025       fi
2026     done
2027   fi
2028 }
2029 # }}}
2030
2031 # unmount mountpoint {{{
2032 try_umount() {
2033   local tries=$1
2034   local mountpoint="$2"
2035
2036   for (( try=1; try<=tries; try++ )); do
2037     if [[ ${try} -eq ${tries} ]]; then
2038       # Last time, show errors this time
2039       umount "${mountpoint}" && return 0
2040     else
2041       # Not last time, hide errors until fatal
2042       if umount "${mountpoint}" 2>/dev/null ; then
2043         return 0
2044       else
2045         sleep 1
2046       fi
2047     fi
2048   done
2049   return 1  # Tried enough
2050 }
2051 # }}}
2052
2053 # execute chroot-script {{{
2054 chrootscript() {
2055   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2056     mount_target
2057   fi
2058
2059   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2060     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2061     eend 1
2062   else
2063     einfo "Executing chroot-script now"
2064     mount -t devtmpfs udev "${MNTPOINT}"/dev
2065     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2066     if [ "$DEBUG" = "true" ] ; then
2067       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
2068     else
2069       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
2070     fi
2071     try_umount 3 "$MNTPOINT"/dev/pts
2072     try_umount 3 "$MNTPOINT"/dev
2073     eend $RC
2074   fi
2075
2076   # finally get rid of chroot-script again, there's no good reason to
2077   # keep it on the installed system
2078   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2079     einfo "Removing chroot-script again"
2080     rm -f "${MNTPOINT}/bin/chroot-script"
2081   else
2082     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2083   fi
2084 }
2085 # }}}
2086
2087 # unmount $MNTPOINT {{{
2088 umount_chroot() {
2089
2090   # display installation notes:
2091   if [ -n "$INSTALL_NOTES" ] ; then
2092      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2093   fi
2094
2095   if [ -n "$ISODIR" ] ; then
2096      if grep -q "$ISODIR" /proc/mounts ; then
2097         einfo "Unmount $MNTPOINT/$ISODIR"
2098         umount "$MNTPOINT/$ISODIR"
2099      fi
2100   fi
2101
2102   if grep -q "$MNTPOINT" /proc/mounts ; then
2103     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
2104       einfo "Unmounting bind-mount /run/udev"
2105       umount "${MNTPOINT}"/run/udev
2106     fi
2107
2108      if [ -n "$PARTITION" ] ; then
2109         einfo "Unmount $MNTPOINT"
2110         umount "$MNTPOINT"
2111      fi
2112   fi
2113 }
2114 # }}}
2115
2116 # execute filesystem check {{{
2117 fscktool() {
2118  if [ -n "$VIRTUAL" ] ; then
2119    einfo "Skipping filesystem check because we deploy a virtual machine."
2120    return 0
2121  fi
2122
2123  if [ "$FSCK" = 'yes' ] ; then
2124    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2125    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2126    "$FSCKTOOL" "$TARGET"
2127  fi
2128 }
2129 # }}}
2130
2131 # get rid of grml-debootstrap config files {{{
2132 remove_configs() {
2133   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2134     return 0
2135   fi
2136
2137   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2138     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2139     return 0
2140   fi
2141
2142   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2143   rm -rf "${MNTPOINT}"/etc/debootstrap/
2144 }
2145 # }}}
2146
2147 # now execute all the functions {{{
2148 for i in format_efi_partition prepare_vm mkfs tunefs \
2149          mount_target mountpoint_to_blockdevice debootstrap_system \
2150          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2151          remove_configs umount_chroot grub_install umount_target fscktool ; do
2152     if stage "${i}" ; then
2153       "$i"
2154       stage "${i}" 'done'
2155       rm -f "${STAGES}/${i}"
2156     fi
2157 done
2158
2159 cleanup
2160 # }}}
2161
2162 # end dialog of autoinstallation {{{
2163 if [ -n "$AUTOINSTALL" ] ; then
2164    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2165 Automatically rebooting in 10 seconds.
2166
2167 Choose Cancel to skip rebooting." 10 60 10 ; then
2168      noeject noprompt reboot
2169   fi
2170 else
2171    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2172 fi
2173 # }}}
2174
2175 ## END OF FILE #################################################################
2176 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2